/*3:*/
#line 90 "./mp.w"

typedef struct MP_instance*MP;
/*42:*/
#line 581 "./mp.w"

enum mp_filetype{
mp_filetype_terminal= 0,
mp_filetype_error,
mp_filetype_program,
mp_filetype_log,
mp_filetype_postscript,
mp_filetype_memfile,
mp_filetype_metrics,
mp_filetype_fontmap,
mp_filetype_font,
mp_filetype_encoding,
mp_filetype_text
};
typedef char*(*mp_file_finder)(MP,const char*,const char*,int);
typedef void*(*mp_file_opener)(MP,const char*,const char*,int);
typedef char*(*mp_file_reader)(MP,void*,size_t*);
typedef void(*mp_binfile_reader)(MP,void*,void**,size_t*);
typedef void(*mp_file_closer)(MP,void*);
typedef int(*mp_file_eoftest)(MP,void*);
typedef void(*mp_file_flush)(MP,void*);
typedef void(*mp_file_writer)(MP,void*,const char*);
typedef void(*mp_binfile_writer)(MP,void*,void*,size_t);

/*:42*//*71:*/
#line 1067 "./mp.w"

typedef struct{
unsigned char*str;
size_t len;
int refs;
}mp_lstring;
typedef mp_lstring*str_number;

/*:71*//*117:*/
#line 1809 "./mp.w"

enum mp_interaction_mode{
mp_unspecified_mode= 0,
mp_batch_mode,
mp_nonstop_mode,
mp_scroll_mode,
mp_error_stop_mode
};

/*:117*//*123:*/
#line 1894 "./mp.w"

enum mp_history_state{
mp_spotless= 0,
mp_warning_issued,
mp_error_message_issued,
mp_fatal_error_stop,
mp_system_error_stop
};

/*:123*//*135:*/
#line 2052 "./mp.w"

typedef void(*mp_editor_cmd)(MP,char*,int);

/*:135*//*164:*/
#line 2493 "./mp.w"

#if 1
typedef int scaled;
#else
typedef struct scaled{
int val;
}scaled;
#endif
typedef int fraction;
typedef int angle;

/*:164*//*308:*/
#line 6622 "./mp.w"

typedef struct mp_knot_data*mp_knot;
typedef struct mp_knot_data{
scaled x_coord;
scaled y_coord;
scaled left_x;
scaled left_y;
scaled right_x;
scaled right_y;
mp_knot next;
union{
struct{
unsigned short left_type;
unsigned short right_type;
}types;
mp_knot prev;
signed int info;
}data;
unsigned char originator;
}mp_knot_data;


/*:308*//*311:*/
#line 6731 "./mp.w"

enum mp_knot_originator{
mp_program_code= 0,
mp_metapost_user
};

/*:311*//*905:*/
#line 18455 "./mp.w"

typedef int(*mp_makempx_cmd)(MP mp,char*origname,char*mtxname);

/*:905*//*1193:*/
#line 26276 "./mp.w"

typedef struct{
void*fptr;
char*data;
char*cur;
size_t size;
size_t used;
}mp_stream;
typedef struct{
mp_stream term_out;
mp_stream error_out;
mp_stream log_out;
mp_stream ps_out;
mp_stream term_in;
struct mp_edge_object*edges;
}mp_run_data;

/*:1193*//*1439:*/
#line 30940 "./mp.w"

typedef void(*mp_backend_writer)(MP,void*);

/*:1439*/
#line 92 "./mp.w"
;
typedef struct MP_options{
/*25:*/
#line 399 "./mp.w"

int error_line;
int half_error_line;

int halt_on_error;
int max_print_line;
void*userdata;
char*banner;
int ini_version;

/*:25*//*43:*/
#line 605 "./mp.w"

mp_file_finder find_file;
mp_file_opener open_file;
mp_file_reader read_ascii_file;
mp_binfile_reader read_binary_file;
mp_file_closer close_file;
mp_file_eoftest eof_file;
mp_file_flush flush_file;
mp_file_writer write_ascii_file;
mp_binfile_writer write_binary_file;

/*:43*//*48:*/
#line 678 "./mp.w"

int print_found_names;

/*:48*//*50:*/
#line 696 "./mp.w"

int file_line_error_style;

/*:50*//*66:*/
#line 942 "./mp.w"

char*command_line;

/*:66*//*118:*/
#line 1818 "./mp.w"

int interaction;
int noninteractive;

/*:118*//*136:*/
#line 2055 "./mp.w"

mp_editor_cmd run_editor;

/*:136*//*169:*/
#line 2554 "./mp.w"

int random_seed;

/*:169*//*209:*/
#line 4031 "./mp.w"

int troff_mode;

/*:209*//*872:*/
#line 17901 "./mp.w"

char*mem_name;

/*:872*//*885:*/
#line 18095 "./mp.w"

char*job_name;

/*:885*//*906:*/
#line 18458 "./mp.w"

mp_makempx_cmd run_make_mpx;

/*:906*//*1440:*/
#line 30943 "./mp.w"

mp_backend_writer shipout_backend;

/*:1440*/
#line 94 "./mp.w"

}MP_options;
/*17:*/
#line 346 "./mp.w"

extern MP_options*mp_options(void);
extern MP mp_initialize(MP_options*opt);
extern int mp_status(MP mp);
extern void*mp_userdata(MP mp);

/*:17*//*133:*/
#line 2024 "./mp.w"

extern void mp_error(MP mp);
extern void mp_warn(MP mp,const char*msg);


/*:133*//*150:*/
#line 2316 "./mp.w"

extern void mp_fatal_error(MP mp,const char*s);


/*:150*//*211:*/
#line 4049 "./mp.w"

int mp_troff_mode(MP mp);

/*:211*//*1192:*/
#line 26257 "./mp.w"

void mp_set_internal(MP mp,char*n,char*v,int isstring);

/*:1192*//*1201:*/
#line 26573 "./mp.w"

extern mp_run_data*mp_rundata(MP mp);

/*:1201*//*1209:*/
#line 26723 "./mp.w"

int mp_run(MP mp);
int mp_execute(MP mp,char*s,size_t l);
int mp_finish(MP mp);
char*mp_metapost_version(void);

/*:1209*//*1399:*/
#line 30144 "./mp.w"

double mp_get_char_dimension(MP mp,char*fname,int n,int t);


/*:1399*//*1459:*/
#line 31198 "./mp.w"

int mp_memory_usage(MP mp);
int mp_hash_usage(MP mp);
int mp_param_usage(MP mp);
int mp_open_usage(MP mp);

/*:1459*/
#line 96 "./mp.w"



/*:3*//*215:*/
#line 4166 "./mp.w"

enum mp_color_model{
mp_no_model= 1,
mp_grey_model= 3,
mp_rgb_model= 5,
mp_cmyk_model= 7,
mp_uninitialized_model= 9
};


/*:215*//*309:*/
#line 6644 "./mp.w"

enum mp_knot_type{
mp_endpoint= 0,
mp_explicit,
mp_given,
mp_curl,
mp_open,
mp_end_cycle
};

/*:309*//*448:*/
#line 9256 "./mp.w"

enum mp_graphical_object_code{
/*450:*/
#line 9304 "./mp.w"

mp_fill_code= 1,

/*:450*//*454:*/
#line 9376 "./mp.w"

mp_stroked_code= 2,

/*:454*//*461:*/
#line 9512 "./mp.w"

mp_text_code= 3,

/*:461*//*464:*/
#line 9582 "./mp.w"

mp_start_clip_code= 4,
mp_start_bounds_code= 5,
mp_stop_clip_code= 6,
mp_stop_bounds_code= 7,


/*:464*//*1430:*/
#line 30654 "./mp.w"

mp_special_code= 8,

/*:1430*/
#line 9258 "./mp.w"

mp_final_graphic
};

/*:448*/
