/*3:*/
#line 91 "./mp.w"

typedef struct MP_instance*MP;
/*42:*/
#line 778 "./mp.w"

enum mp_filetype{
mp_filetype_terminal= 0,
mp_filetype_error,
mp_filetype_program,
mp_filetype_log,
mp_filetype_postscript,
mp_filetype_memfile,
mp_filetype_metrics,
mp_filetype_fontmap,
mp_filetype_font,
mp_filetype_encoding,
mp_filetype_text
};
typedef char*(*mp_file_finder)(MP,const char*,const char*,int);
typedef void*(*mp_file_opener)(MP,const char*,const char*,int);
typedef char*(*mp_file_reader)(MP,void*,size_t*);
typedef void(*mp_binfile_reader)(MP,void*,void**,size_t*);
typedef void(*mp_file_closer)(MP,void*);
typedef int(*mp_file_eoftest)(MP,void*);
typedef void(*mp_file_flush)(MP,void*);
typedef void(*mp_file_writer)(MP,void*,const char*);
typedef void(*mp_binfile_writer)(MP,void*,void*,size_t);

/*:42*//*72:*/
#line 1256 "./mp.w"

typedef struct{
unsigned char*str;
size_t len;
int refs;
}mp_lstring;
typedef mp_lstring*mp_string;

/*:72*//*98:*/
#line 1698 "./mp.w"

enum mp_interaction_mode{
mp_unspecified_mode= 0,
mp_batch_mode,
mp_nonstop_mode,
mp_scroll_mode,
mp_error_stop_mode
};

/*:98*//*104:*/
#line 1777 "./mp.w"

enum mp_history_state{
mp_spotless= 0,
mp_warning_issued,
mp_error_message_issued,
mp_fatal_error_stop,
mp_system_error_stop
};

/*:104*//*118:*/
#line 1942 "./mp.w"

typedef void(*mp_editor_cmd)(MP,char*,int);

/*:118*//*162:*/
#line 2628 "./mp.w"

typedef struct mp_number_data*mp_number;
typedef enum{
mp_math_scaled_mode= 0,
mp_math_double_mode= 1,
mp_math_binary_mode= 2,
mp_math_decimal_mode= 3,
}mp_math_mode;

/*:162*//*302:*/
#line 6735 "./mp.w"

typedef struct mp_knot_data*mp_knot;
typedef struct mp_knot_data{
mp_number x_coord;
mp_number y_coord;
mp_number left_x;
mp_number left_y;
mp_number right_x;
mp_number right_y;
mp_knot next;
union{
struct{
unsigned short left_type;
unsigned short right_type;
}types;
mp_knot prev;
signed int info;
}data;
unsigned char originator;
}mp_knot_data;


/*:302*//*303:*/
#line 6760 "./mp.w"

typedef struct mp_gr_knot_data*mp_gr_knot;
typedef struct mp_gr_knot_data{
double x_coord;
double y_coord;
double left_x;
double left_y;
double right_x;
double right_y;
mp_gr_knot next;
union{
struct{
unsigned short left_type;
unsigned short right_type;
}types;
mp_gr_knot prev;
signed int info;
}data;
unsigned char originator;
}mp_gr_knot_data;


/*:303*//*306:*/
#line 6869 "./mp.w"

enum mp_knot_originator{
mp_program_code= 0,
mp_metapost_user
};

/*:306*//*919:*/
#line 20951 "./mp.w"

typedef int(*mp_makempx_cmd)(MP mp,char*origname,char*mtxname);

/*:919*//*1205:*/
#line 29329 "./mp.w"

typedef struct{
void*fptr;
char*data;
char*cur;
size_t size;
size_t used;
}mp_stream;
typedef struct{
mp_stream term_out;
mp_stream error_out;
mp_stream log_out;
mp_stream ps_out;
mp_stream term_in;
struct mp_edge_object*edges;
}mp_run_data;

/*:1205*//*1455:*/
#line 34201 "./mp.w"

typedef void(*mp_backend_writer)(MP,void*);

/*:1455*/
#line 93 "./mp.w"
;
typedef struct MP_options{
/*26:*/
#line 607 "./mp.w"

int error_line;
int half_error_line;

int halt_on_error;
int max_print_line;
void*userdata;
char*banner;
int ini_version;

/*:26*//*43:*/
#line 802 "./mp.w"

mp_file_finder find_file;
mp_file_opener open_file;
mp_file_reader read_ascii_file;
mp_binfile_reader read_binary_file;
mp_file_closer close_file;
mp_file_eoftest eof_file;
mp_file_flush flush_file;
mp_file_writer write_ascii_file;
mp_binfile_writer write_binary_file;

/*:43*//*48:*/
#line 872 "./mp.w"

int print_found_names;

/*:48*//*50:*/
#line 890 "./mp.w"

int file_line_error_style;

/*:50*//*66:*/
#line 1131 "./mp.w"

char*command_line;

/*:66*//*99:*/
#line 1707 "./mp.w"

int interaction;
int noninteractive;

/*:99*//*119:*/
#line 1945 "./mp.w"

mp_editor_cmd run_editor;

/*:119*//*151:*/
#line 2440 "./mp.w"

int random_seed;

/*:151*//*163:*/
#line 2637 "./mp.w"

int math_mode;

/*:163*//*194:*/
#line 3945 "./mp.w"

int troff_mode;

/*:194*//*886:*/
#line 20400 "./mp.w"

char*mem_name;

/*:886*//*899:*/
#line 20591 "./mp.w"

char*job_name;

/*:899*//*920:*/
#line 20954 "./mp.w"

mp_makempx_cmd run_make_mpx;

/*:920*//*1456:*/
#line 34204 "./mp.w"

mp_backend_writer shipout_backend;

/*:1456*/
#line 95 "./mp.w"

}MP_options;
/*18:*/
#line 554 "./mp.w"

extern MP_options*mp_options(void);
extern MP mp_initialize(MP_options*opt);
extern int mp_status(MP mp);
extern void*mp_userdata(MP mp);

/*:18*//*116:*/
#line 1914 "./mp.w"

extern void mp_error(MP mp,const char*msg,const char**hlp,boolean deletions_allowed);
extern void mp_warn(MP mp,const char*msg);


/*:116*//*133:*/
#line 2205 "./mp.w"

extern void mp_fatal_error(MP mp,const char*s);


/*:133*//*196:*/
#line 3967 "./mp.w"

int mp_troff_mode(MP mp);

/*:196*//*1204:*/
#line 29310 "./mp.w"

void mp_set_internal(MP mp,char*n,char*v,int isstring);

/*:1204*//*1213:*/
#line 29626 "./mp.w"

extern mp_run_data*mp_rundata(MP mp);

/*:1213*//*1221:*/
#line 29776 "./mp.w"

int mp_run(MP mp);
int mp_execute(MP mp,char*s,size_t l);
int mp_finish(MP mp);
char*mp_metapost_version(void);

/*:1221*//*1415:*/
#line 33386 "./mp.w"

double mp_get_char_dimension(MP mp,char*fname,int n,int t);


/*:1415*//*1473:*/
#line 34446 "./mp.w"

int mp_memory_usage(MP mp);
int mp_hash_usage(MP mp);
int mp_param_usage(MP mp);
int mp_open_usage(MP mp);

/*:1473*/
#line 97 "./mp.w"



/*:3*//*200:*/
#line 4084 "./mp.w"

enum mp_color_model{
mp_no_model= 1,
mp_grey_model= 3,
mp_rgb_model= 5,
mp_cmyk_model= 7,
mp_uninitialized_model= 9
};


/*:200*//*304:*/
#line 6782 "./mp.w"

enum mp_knot_type{
mp_endpoint= 0,
mp_explicit,
mp_given,
mp_curl,
mp_open,
mp_end_cycle
};

/*:304*//*458:*/
#line 10575 "./mp.w"

enum mp_graphical_object_code{
/*460:*/
#line 10615 "./mp.w"

mp_fill_code= 1,

/*:460*//*464:*/
#line 10686 "./mp.w"

mp_stroked_code= 2,

/*:464*//*471:*/
#line 10862 "./mp.w"

mp_text_code= 3,

/*:471*//*474:*/
#line 10943 "./mp.w"

mp_start_clip_code= 4,
mp_start_bounds_code= 5,
mp_stop_clip_code= 6,
mp_stop_bounds_code= 7,


/*:474*//*1446:*/
#line 33902 "./mp.w"

mp_special_code= 8,

/*:1446*/
#line 10577 "./mp.w"

mp_final_graphic
};

/*:458*/
