#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>

#define  RMODE "rb"
#define  WMODE "wb"

FILE *Finp, *Fout;

void
usage(char *s)
{
  fprintf(stderr, "utf8towutf8 adds three header bytes to a utf8 text.\n");
  fprintf(stderr, "Usage: %s [input] [output]\n", s);
}

int
main(int argc, char *argv[])
{
  int a = 1;

  strcpy(argv[0], "utf8towutf8");
  setmode(fileno(stdin), _O_BINARY);
  setmode(fileno(stdout), _O_BINARY);

  Finp = stdin;
  Fout = stdout;

  if(a == argc - 1) {
    Finp = fopen(argv[a], RMODE);
    if(!Finp) {
      fprintf(stderr, "I cannot open %s to read.\n", argv[a]);
      return 1;
    }
  }
  else if(a == argc - 2) {
    Finp = fopen(argv[a], RMODE);
    if(!Finp) {
      fprintf(stderr, "I cannot open %s to read.\n", argv[a]);
      return 1;
    }
    Fout = fopen(argv[++a], WMODE);
    if(!Fout) {
      fprintf(stderr, "I cannot open %s to write.\n", argv[a]);
      return 1;
    }
  }
  else if(a != argc){
    fprintf(stderr, "Wrong arguments.\n");
    usage(argv[0]);
    return 2;
  }

  putc(0xef, Fout);
  putc(0xbb, Fout);
  putc(0xbf, Fout);
  while((a = getc(Finp)) != EOF)
    putc(a, Fout);

  if(Finp != stdin)  fclose(Finp);
  if(Fout != stdout) fclose(Fout);

  return 0;
}
