/*5:*/
#line 37 "./mpmath.w"

/*7:*/
#line 46 "./mpmath.w"

typedef struct math_data{
scaled max_scaled_;
scaled one_third_max_scaled_;
scaled unity_;
scaled two_;
scaled three_;
scaled half_unit_;
scaled three_quarter_unit_;
fraction fraction_one_;
fraction fraction_half_;
fraction fraction_two_;
fraction fraction_three_;
fraction fraction_four_;
angle ninety_deg_;
angle one_eighty_deg_;
angle three_sixty_deg_;
}math_data;

/*:7*/
#line 38 "./mpmath.w"
;
/*8:*/
#line 65 "./mpmath.w"

void*mp_initialize_math(MP mp);
void mp_free_math(MP mp);

/*:8*//*11:*/
#line 124 "./mpmath.w"

#define half(A) ((A) / 2)
#define halfp(A) (integer)((unsigned)(A) >> 1)

/*:11*//*12:*/
#line 130 "./mpmath.w"

#define integer_as_fraction(A) (fraction)(A)


/*:12*//*13:*/
#line 148 "./mpmath.w"

void mp_print_scaled(MP mp,scaled s);

/*:13*//*15:*/
#line 177 "./mpmath.w"

integer mp_slow_add(MP mp,integer x,integer y);

/*:15*//*17:*/
#line 235 "./mpmath.w"

fraction mp_make_fraction(MP mp,integer p,integer q);

/*:17*//*19:*/
#line 291 "./mpmath.w"

integer mp_take_fraction(MP mp,integer q,fraction f);

/*:19*//*21:*/
#line 334 "./mpmath.w"

integer mp_take_scaled(MP mp,integer q,scaled f);

/*:21*//*23:*/
#line 373 "./mpmath.w"

scaled mp_make_scaled(MP mp,integer p,integer q);

/*:23*//*25:*/
#line 411 "./mpmath.w"

scaled mp_divide_scaled(MP mp,scaled s,scaled m,integer dd);

/*:25*//*27:*/
#line 449 "./mpmath.w"

scaled mp_round_decimals(MP mp,unsigned char*b,quarterword k);

/*:27*//*30:*/
#line 499 "./mpmath.w"

fraction mp_velocity(MP mp,fraction st,fraction ct,fraction sf,
fraction cf,scaled t);

/*:30*//*32:*/
#line 532 "./mpmath.w"

integer mp_ab_vs_cd(MP mp,integer a,integer b,integer c,integer d);

/*:32*//*36:*/
#line 594 "./mpmath.w"

#define mp_floor_scaled(M,i) ((i)&(-65536))

/*:36*//*37:*/
#line 598 "./mpmath.w"

#define mp_round_unscaled(M,x) (x>=0100000 ? 1+((x-0100000) / 0200000) \
  : ( x>=-0100000 ? 0 : -(1+((-(x+1)-0100000) / 0200000))))

/*:37*//*38:*/
#line 603 "./mpmath.w"

#define mp_round_fraction(M,x) (x>=2048 ? 1+((x-2048) / 4096) \
  : ( x>=-2048 ? 0 : -(1+((-(x+1)-2048) / 4096))))



/*:38*//*40:*/
#line 621 "./mpmath.w"

scaled mp_square_rt(MP mp,scaled x);

/*:40*//*44:*/
#line 699 "./mpmath.w"

integer mp_pyth_add(MP mp,integer a,integer b);


/*:44*//*47:*/
#line 754 "./mpmath.w"

integer mp_pyth_sub(MP mp,integer a,integer b);

/*:47*//*52:*/
#line 841 "./mpmath.w"

scaled mp_m_log(MP mp,scaled x);

/*:52*//*56:*/
#line 898 "./mpmath.w"

scaled mp_m_exp(MP mp,scaled x);

/*:56*//*60:*/
#line 986 "./mpmath.w"

angle mp_n_arg(MP mp,integer x,integer y);

/*:60*//*67:*/
#line 1124 "./mpmath.w"

void mp_n_sin_cos(MP mp,angle z,fraction*n_cos,fraction*n_sin);

/*:67*/
#line 39 "./mpmath.w"
;

/*:5*/
